"""
Generated by qenerate plugin=pydantic_v1. DO NOT MODIFY MANUALLY!
"""
from collections.abc import Callable  # noqa: F401 # pylint: disable=W0611
from datetime import datetime  # noqa: F401 # pylint: disable=W0611
from enum import Enum  # noqa: F401 # pylint: disable=W0611
from typing import (  # noqa: F401 # pylint: disable=W0611
    Any,
    Optional,
    Union,
)

from pydantic import (  # noqa: F401 # pylint: disable=W0611
    BaseModel,
    Extra,
    Field,
    Json,
)

from reconcile.gql_definitions.fragments.vault_secret import VaultSecret


DEFINITION = """
fragment VaultSecret on VaultSecret_v1 {
    path
    field
    version
    format
}

query JiraWatcherBoards {
  jira_boards: jira_boards_v1 {
    path
    name
    server {
      serverUrl
      token {
        ... VaultSecret
      }
    }
    slack {
      workspace {
        name
        integrations {
          name
          token {
            ... VaultSecret
          }
          channel
          icon_emoji
          username
        }
        api_client {
          global {
            max_retries
            timeout
          }
          methods {
            name
            args
          }
        }
      }
      channel
    }
  }
}
"""


class ConfiguredBaseModel(BaseModel):
    class Config:
        smart_union = True
        extra = Extra.forbid


class JiraServerV1(ConfiguredBaseModel):
    server_url: str = Field(..., alias="serverUrl")
    token: VaultSecret = Field(..., alias="token")


class SlackWorkspaceIntegrationV1(ConfiguredBaseModel):
    name: str = Field(..., alias="name")
    token: VaultSecret = Field(..., alias="token")
    channel: str = Field(..., alias="channel")
    icon_emoji: str = Field(..., alias="icon_emoji")
    username: str = Field(..., alias="username")


class SlackWorkspaceApiClientGlobalConfigV1(ConfiguredBaseModel):
    max_retries: Optional[int] = Field(..., alias="max_retries")
    timeout: Optional[int] = Field(..., alias="timeout")


class SlackWorkspaceApiClientMethodConfigV1(ConfiguredBaseModel):
    name: str = Field(..., alias="name")
    args: Json = Field(..., alias="args")


class SlackWorkspaceApiClientV1(ConfiguredBaseModel):
    q_global: Optional[SlackWorkspaceApiClientGlobalConfigV1] = Field(
        ..., alias="global"
    )
    methods: Optional[list[SlackWorkspaceApiClientMethodConfigV1]] = Field(
        ..., alias="methods"
    )


class SlackWorkspaceV1(ConfiguredBaseModel):
    name: str = Field(..., alias="name")
    integrations: Optional[list[SlackWorkspaceIntegrationV1]] = Field(
        ..., alias="integrations"
    )
    api_client: Optional[SlackWorkspaceApiClientV1] = Field(..., alias="api_client")


class SlackOutputV1(ConfiguredBaseModel):
    workspace: SlackWorkspaceV1 = Field(..., alias="workspace")
    channel: Optional[str] = Field(..., alias="channel")


class JiraBoardV1(ConfiguredBaseModel):
    path: str = Field(..., alias="path")
    name: str = Field(..., alias="name")
    server: JiraServerV1 = Field(..., alias="server")
    slack: Optional[SlackOutputV1] = Field(..., alias="slack")


class JiraWatcherBoardsQueryData(ConfiguredBaseModel):
    jira_boards: Optional[list[JiraBoardV1]] = Field(..., alias="jira_boards")


def query(query_func: Callable, **kwargs: Any) -> JiraWatcherBoardsQueryData:
    """
    This is a convenience function which queries and parses the data into
    concrete types. It should be compatible with most GQL clients.
    You do not have to use it to consume the generated data classes.
    Alternatively, you can also mime and alternate the behavior
    of this function in the caller.

    Parameters:
        query_func (Callable): Function which queries your GQL Server
        kwargs: optional arguments that will be passed to the query function

    Returns:
        JiraWatcherBoardsQueryData: queried data parsed into generated classes
    """
    raw_data: dict[Any, Any] = query_func(DEFINITION, **kwargs)
    return JiraWatcherBoardsQueryData(**raw_data)
